<template>
  <main>
    <mt-controle-activites
      :type-activite-selected="typeActiviteSelected"
      :is-my-activities="false"
      :date-courante="currentMonthDate"
      @filtrer-type-activite="filtrerTypeActivite"
    />
    <mt-box-activites :date-courante="currentMonthDate" @mois-selectionne="moisSelectionne">
      <mt-calendar-annuel :donnees="activiteAnnuel"></mt-calendar-annuel>
    </mt-box-activites>
  </main>
</template>

<script>
import { DateTime } from 'luxon';
import MtBoxActivites from '~/components/activity/box-activites';
import MtControleActivites from '~/components/activity/controle-activites';
import { calendarParent } from '~/components/mixins/calendarMixin';
import userMixin from '~/components/mixins/userMixin';
import MtCalendarAnnuel from '~/components/calendar/annuel/index';

export default {
  components: {
    MtCalendarAnnuel,
    MtBoxActivites,
    MtControleActivites,
  },
  mixins: [calendarParent, userMixin],
  data() {
    return {
      typeActiviteSelected: [],
    };
  },
  watch: {
    organisme: {
      handler() {
        this.reloadActivite();
      },
      immediate: true,
    },
  },
  watchQuery: ['mois'],
  async asyncData(context) {
    const moisCourant =
      context.query && context.query.mois ? DateTime.fromFormat(context.query.mois, 'yyyy-MM').toJSDate() : new Date();
    const activiteAnnuel = await context.$api.organisme().activiteAnnuel(DateTime.fromJSDate(moisCourant).toISO(), []);

    return {
      activiteAnnuel,
      currentMonthDate: moisCourant,
    };
  },
  methods: {
    filtrerTypeActivite(newValue) {
      this.typeActiviteSelected = newValue;
      this.reloadActivite();
    },
    moisSelectionne({ startDate }) {
      this.currentMonthDate = startDate;
      this.$router.replace({
        query: { mois: DateTime.fromJSDate(startDate).toFormat('yyyy-MM') },
      });
      this.reloadActivite();
    },
    async reloadActivite() {
      this.activiteAnnuel = await this.$api
        .organisme()
        .activiteAnnuel(DateTime.fromJSDate(this.currentMonthDate).toISO(), this.typeActiviteSelected);
    },
  },
};
</script>
<style lang="scss" scoped>
.mt-box-activites-calendar {
  padding: 1rem;
}
</style>
